(function() {
	var path = require('path');
	var fs = require('fs');
	var Dir = {
		Dirs: function Dirs(dirPath, recurse) {
			return (Dir.List(dirPath, recurse)).dirs;			
		},
		Files: function Files(dirPath, recurse) {
			return (Dir.List(dirPath, recurse)).files;
		},
		List: function List(dirPath, recurse) {
			m = Dir.Map(dirPath, recurse);
		
			var files = new Array();
			var dirs = new Array();

			m.files.forEach(function (e, i, a) {
				files.push(path.normalize(dirPath)+"/"+path.normalize(e));
			});

			(Object.keys(m.dirs)).forEach(function (e, i, a) {
				var list = {files: new Array(), dirs: new Array()};
				if (typeof e === 'string') {
					dirs.push(path.normalize(dirPath)+"\\"+e);
					if (recurse)
						list = Dir.List(path.normalize(dirPath)+"\\"+e, true);
				} else {
					dirs.push(path.normalize(dirPath)+"\\"+e);
					if (recurse)
						list = Dir.List(path.normalize(dirPath)+"\\"+e.path, true);
				}

				list.files.forEach(function (e, i, a) {
					files.push(path.normalize(e));
				});
				list.dirs.forEach(function (e, i, a) {
					dirs.push(path.normalize(a[e]));
				});
			});
			return {files: files, dirs: dirs};
		},
		Map: function Map(dirPath, recurse) {
			var m = {path: dirPath, files: new Array(), dirs: new Object()};
			(fs.readdirSync(path.normalize(dirPath))).forEach(function (e, i, a) {
				if ((fs.statSync(path.normalize(dirPath)+"/"+e)).isFile()) {
					m.files.push(e);
				}
				if ((fs.statSync(path.normalize(dirPath)+"/"+e)).isDirectory()) {
					if (recurse === true) {
						m.dirs[e] = Dir.Map(path.normalize(dirPath)+"/"+e, recurse);
					} else {
						m.dirs[e] = path.normalize(dirPath)+"/"+e;
					}
				}
			});
			return m;
		}
	};

	if (typeof(module) != 'undefined') {
		module.exports = Dir;
	} else {
		this.Dir = Dir;
	}

})();
